%%
%% This is file `exams.cls',
%% generated with the docstrip utility.
%%
%% The original source files were:
%%
%% exams.dtx  (with options: `cls')
%% Copyright (C) 1993-1996 Hans van der Meer. All rights reserved.
\NeedsTeXFormat{LaTeX2e}[1995/12/01]
\ProvidesClass{exams}[1997/03/14 vs 3.30 exams package]
\newif\ifanswers
\answersfalse
\DeclareOption{answers}{\answerstrue\scorestrue}
\newif\ifproblempages
\problempagesfalse
\DeclareOption{pages}{\problempagestrue\problemsepfalse}
\newif\ifreservespace
\reservespacetrue
\DeclareOption{questiononly}{\reservespacefalse}
\newif\ifproblemsep
\problemseptrue
\DeclareOption{nosep}{\problemsepfalse}
\newif\ifscores
\scoresfalse
\DeclareOption{scores}{\scorestrue}
\newif\ifseries
\seriesfalse
\DeclareOption{series}{\seriestrue\answerstrue\scorestrue}
\DeclareOption{help}{\ClassWarningNoLine{exam}{%
    available options for exam:\MessageBreak
    answers:\space show questions with answers;\MessageBreak
    nosep:\space no separators between problems;\MessageBreak
    pages:\space each problem on a page;\MessageBreak
    questiononly:\space suppress answer space in exams;\MessageBreak
    scores:\space typeset score values always;\MessageBreak
    series:\space\space typeset catalogue of problems}}
\providecommand\parentclass{article}
\DeclareOption*{\PassOptionsToClass{\CurrentOption}{\parentclass}}
\PassOptionsToClass{titlepage}{\parentclass}
\ProcessOptions
\LoadClass{\parentclass}
\ifseries\else\ifanswers\else\let\tableofcontents=\relax\fi\fi
\providecommand\@ifemptyarg[1]{% {absence}{presence}
  \ifx\@empty#1\@empty
  \expandafter\@firstoftwo\else\expandafter\@secondoftwo\fi}
\newcommand*\examerror[2]{\ClassError{exam}{!!!! #1}{#2}}
\newcommand*\examwarning[1]{\ClassWarning{exam}{!!!! #1}}
\newcounter{examnum}
\newenvironment{exam}[2][0]{%
  \stepcounter{examnum}%
  \@ifemptyarg{#2}{}{\date{#2}}%
  \ifanswers
    \pagenumbering{roman}%
    \maketitle\newpage%\mbox{}\newpage
  \fi
  \pagenumbering{arabic}%
  \ifseries\SRset{0}\else
    \SRset{#1}%
    \addtocontents{toc}{\protect\contentsline{section}%
      {\Exam~\theexamnum~\textemdash~\@date~%
      \textemdash~random start #1}{}}%
  \fi
  \setcounter{page}{1}}%
  {\ifseries\else
    \typeout{Total value scores = \thetotalscore}%
    \ifanswers
      \addtocontents{toc}{\protect\contentsline{section}%
        {Total value scores = \thetotalscore}{}}%
    \else\maketitle
    \fi\fi}
\newcounter{problemnum}[examnum]
\newtoks\problemid
\newcommand*\question[3][]{%
  \@ifemptyarg{#1}{}{\renewcommand\parameter{#1}}%
  \ifseries
    \uppercase{\def\@namesection{#2}}%
    \ifx\namesection\@namesection
    \else
      \newpage
      \global\let\namesection=\@namesection
      \addcontentsline{toc}{subsection}{\namesection}%
      \setcounter{problemnum}{0}%
    \fi
  \fi
  \problemid={\MakeUppercase{#3}}%
  \ifseries
    \noindent\underbar{\emph{File\,:}~\texttt{\the\problemid}}\par
    \nopagebreak\medskip\nopagebreak
  \fi
  \stepcounter{problemnum}%
  \ifanswers
    \addcontentsline{toc}{subsection}%
      {\hbox to1cm{\theproblemnum:\hss}#3}%
  \fi
  \edef\@curquestion{\mainfolder\@ifemptyarg{#2}{}{#2\@currdir}#3}%
  \IfFileExists{\@curquestion}{\@@input \@curquestion}%
    {\examwarning{File \@curquestion: not found}}%
  \ifseries\else
    \addtocounter{totalscore}{\value{scorecounter}}%
    \typeout{\Problem\space\theproblemnum: score=\thescorecounter}%
  \fi
  }
\newcommand*\namesection{\Collection}
\newcommand*\reset@parameter{\gdef\parameter{}}
\reset@parameter
\newcommand\parameterproblem[2][1 ]{%
  \ifx\parameter\@empty
    \ifseries\else\examwarning{\string\parameter\space set to `#1'}\fi
    \renewcommand\parameter{#1}%
  \fi
  \remark[Parameter \Problem]{#2}}
\newtoks\everyproblem
\newenvironment{problem}[1][]{%
\compact\the\everyproblem#1\relax
  \@boxing\bgroup\noindent\problemstart\ignorespaces}%
  {\par\ifproblemsep
    \nopagebreak\smallskip\nopagebreak
    \hbox to\linewidth{\hrulefill
      \ifseries
        \emph{\footnotesize\thinspace\the\@problemdate}%
      \fi}\fi
  \egroup\par
  \ifproblempages\newpage\else\bigskip\fi
  \reset@problemdate\reset@parameter}
\newcommand*\compact{\def\@boxing{\noindent\vbox}}
\newcommand*\split{\def\@boxing{}}
\newcommand*\problemstart{%
  \hangafter-2\settowidth\hangindent{\@problemstart}%
  \noindent\llap{\@problemstart}}
\newcommand*\@problemstart{%
  \textbf{\Problem\,\ifnum\value{problemnum}<10 \phantom{0}\fi
  \theproblemnum}.\enskip}
\newtoks\@problemdate
\newcommand*\problemdate[1]{\global\@problemdate={#1}\ignorespaces}
\newcommand*\reset@problemdate{\global\@problemdate={}}
\reset@problemdate
\newcounter{totalscore}[examnum]
\newcounter{scorecounter}[problemnum]
\newcommand*\scoreboxsize{6mm}
\newcommand*\scorebox[1]{%
  \fbox{\vbox to\scoreboxsize{\vss\hbox to
    \scoreboxsize{\hss#1\hss}\vss}}}
\newcommand*\score[1]{%
  \addtocounter{scorecounter}{#1}%
  \rightnote{\scorebox{\ifscores#1\fi}}%
  \ignorespaces}
\providecommand\leftnote{\@rlnote l}
\providecommand\rightnote{\@rlnote r}
\providecommand\@rlnote[2]{%
  \leavevmode\noindent
  \vadjust{\vbox to\z@{%
    \leftskip\z@skip\rightskip\z@skip
    \noindent
    \if#1l\llap{#2\hskip\marginparsep}%
    \else\hfill\rlap{\null\hskip\marginparsep\relax#2}\fi
    \vss\vskip\z@skip
  }}\ignorespaces}
\newcommand\remark[2][]{%
  \ifseries
    \begin{center}%
      \fbox{\parbox{.9\linewidth}{%
        \sloppy\hangafter\@ne
        \sbox\@tempboxa{\emph{#1}\@ifemptyarg{#1}{}{:~}}%
        \hangindent=\wd\@tempboxa
        \strut\usebox{\@tempboxa}#2}}%
      \end{center}%
    \nopagebreak\addvspace{\bigskipamount}\nopagebreak
  \fi}
\newcommand*\longwhite{25mm}
\newcommand*\shortwhite{8mm}
\newcommand*\answerstart{\noindent\emph{\Answer}:\enspace}

\newcommand*\answer[2][]{\altanswer[#1]{}{#2}}
\newcommand*\altanswer[3][]{%
  \@ifemptyarg{#1}%
    {\mbox{\ifanswers#3\else#2\fi}}%
    {\makebox[#1]{\ifanswers#3\else#2\fi}}%
  }
\newcommand*\shortanswer[1]{\par
  \ifanswers
    \addvspace{\smallskipamount}%
    \settowidth\@tempdima{\answerstart\quad}%
    \setlength\@tempdimb{\linewidth}%
    \addtolength\@tempdimb{-\@tempdima}%
    \answerstart\parbox[t]{\@tempdimb}{\noindent#1}%
    \par\medskip
  \else\ifreservespace
    \addvspace{\shortwhite}%
    \answerstart\mbox{}\dotfill\quad\mbox{}\par
    \medskip
   \fi\fi
  }
\newenvironment{longanswer}[1][\longwhite]{
  \par
  \ifanswers
    \addvspace{\medskipamount}\answerstart
    \nopagebreak\par\noindent
  \else\ifreservespace
      \addvspace{\medskipamount}\answerstart
      \nopagebreak\par\noindent
      \hrule\@height#1\@width\z@\par
    \fi
    \setbox\z@\vbox\bgroup\leavevmode
   \fi\ignorespaces}
  {\ifanswers\par\medskip\else\egroup\setbox\z@\hbox{}\fi}
\newcount\loadcounter
\newcommand*\resetloadcounter{\global\loadcounter\z@}
\newcommand*\incloadcounter{\global\advance\loadcounter\@ne}
\newcommand*\decloadcounter{\global\advance\loadcounter\m@ne}
\newcommand*\@listk{%
  \settowidth{\leftmargin}{\@problemstart}%
  \topsep\medskipamount
  \partopsep\z@
  \itemsep\smallskipamount
  \parsep\z@}
\newenvironment{choice}[1][]{%
  \ifseries\ordered\else\random\fi#1\relax
  \resetloadcounter
  \ifnum\@itemdepth>3 \@toodeep \else
  \advance\@itemdepth\@ne
  \expandafter\let
    \csname @list\romannumeral\the\@itemdepth\endcsname=\@listk
  \list{\badmark}{\def\makelabel##1{\hss\llap{##1}}}%
  \fi}%
  {\@dumpitems\endlist}
\newcommand*\random{%
  \def\@loaditem{\loaditem}%
  \def\@dumpitems{\shuffle\dumpitems}}
\newcommand*\ordered{\def\@loaditem{}\def\@dumpitems{}}
\newcommand*\marksize{\fontsize{12}{\f@baselineskip}\selectfont}
\newcommand*\badmark{{\marksize\ensuremath{\square}}}
\newcommand*\goodmark{%
  \ifanswers{\marksize\ensuremath{\boxtimes}}\else\badmark\fi}
\newcommand*\baditem[1]{\@loaditem{\item[\badmark]#1}}
\newcommand*\gooditem[1]{\@loaditem{\item[\goodmark]#1}}
\newtoks\@itemA
\newtoks\@itemB
\newtoks\@itemC
\newtoks\@itemD
\newtoks\@itemE
\newcommand\@itemstore{5}
\newcommand\loaditem[1]{%
  \ifcase\loadcounter
    \@itemA={#1}%
    \or\@itemB={#1}%
    \or\@itemC={#1}%
    \or\@itemD={#1}%
    \or\@itemE={#1}%
  \fi
  \ifnum\loadcounter<\@itemstore \incloadcounter
  \else\examwarning{\string\loaditem\space ignored, too many}\fi}
\newcommand*\dumpitemno[1]{%
  \ifnum#1>\loadcounter
    \examwarning{\string\dumpitemno[#1] ignored, out range}%
  \else\ifcase#1\relax
    \or\the\@itemA
    \or\the\@itemB
    \or\the\@itemC
    \or\the\@itemD
    \or\the\@itemE
  \fi\fi}
\newcommand*\dumpitem{\dumpitemno{\loadcounter}\decloadcounter}
\newcommand*\dumpitems{\@whilenum\loadcounter>\z@\do{\dumpitem}}
\newcommand*\shuffle{%
  \ifcase\loadcounter
    \or
    \or\shuffle@ii
    \or\shuffle@\@itemA\@itemC \shuffle@ii \shuffle@\@itemB\@itemC
    \or\shuffle@iv
    \or\shuffle@\@itemD\@itemE \shuffle@iv \shuffle@\@itemD\@itemE
    \fi
  }
\newtoks\@item@
\newcommand*\shuffle@[2]{\SRtest{}{\@item@=#1 #1=#2 #2=\@item@}}
\newcommand*\shuffle@ii{\shuffle@\@itemA\@itemB}
\newcommand*\shuffle@iv{%
  \SRtest{\shuffle@\@itemA\@itemB}{\shuffle@\@itemC\@itemD}%
  \SRtest{\shuffle@\@itemA\@itemC}{\shuffle@\@itemB\@itemD}}
\ifx\@SR\undefined\newcount\@SR\fi
\providecommand\@SRconst{2097152}
\providecommand\SRset[1]{\global\@SR#1 \ignorespaces}
\providecommand\@SRadvance{%
  \begingroup
  \ifnum\@SR<\@SRconst\relax\count@\z@\else\count@\@ne\fi
  \ifodd\@SR\advance\count@\@ne\fi
  \global\divide\@SR\tw@
  \ifodd\count@\global\advance\@SR\@SRconst\relax\fi
  \endgroup}
\providecommand\SRbit{\@SRadvance\ifodd\@SR1\else0\fi}
\providecommand\SRtest[2]{\@SRadvance
  \ifodd\@SR#2\else#1\fi\ignorespaces}
\providecommand\SRvalue{\number\@SR }
\SRset{0}
\newcommand*\thehead{%
  \textsl{\@title\enspace:\enspace
  \ifseries\namesection\else\@date\fi}}
\newcommand*\ps@examheadings{%
  \let\@oddfoot\@empty
  \let\@evenfoot\@empty
  \renewcommand*\@oddhead{%
    \vbox{%
    \hbox to\textwidth{\headerfont\thehead\hfil\upshape\thepage}%
    \vskip1.5\p@
    \hrule\@height.5\p@\@width\textwidth
    }}%
  \let\@evenhead\@oddhead}
\newcommand*\target[1]{\gdef\@target{#1}}\def\@target{}
\newcommand*\Exam{EXAM}
\newcommand*\Collection{COLLECTION OF EXAMS}
\newcommand*\Answers{ANSWERS}
\newcommand*\Answer{Answer}
\newcommand*\Problem{Problem}
\newcommand*\headerfont{\rmfamily\small}
\newcommand*\bodyfont{\sffamily}
\newcommand*\titlefont{\rmfamily\upshape}
\bodyfont
\let\CurrentDirectory=\@currdir
\def\DirectorySeparator#1#2`\^^M{\@ifemptyarg{#2}{#1}{#2}}
\edef\DirectorySeparator{%
\expandafter\DirectorySeparator\CurrentDirectory`\^^M}
\providecommand*{\LastChar}[1]{%
  \@ifemptyarg{#1}{}{\expandafter\@lastchar#1`\^^M}}
\def\@lastchar#1#2`\^^M{\@ifemptyarg{#2}{#1}{\@lastchar#2`\^^M}}
\providecommand*{\DirectoryName}[1]{\@ifemptyarg{#1}{}%
  {\if\LastChar{#1}\DirectorySeparator\relax#1\else
    #1\DirectorySeparator\fi}}
\newcommand*\Setfolder[2]{\edef#1{\DirectoryName{#2}}}
\InputIfFileExists{exams.cfg}{}{}
\providecommand\square{\bigcirc}
\providecommand\boxtimes{\surd}
\endinput
%%
%% End of file `exams.cls'.
